#!/usr/local/bin/bash

gid_count=0

DEVS=$1
if [ -z "$DEVS" ] ; then
        sysctl sys.class.infiniband_verbs > /dev/null 2>&1
        if [  $? -eq 0 ] ; then
	        DEVS=$(sysctl sys.class.infiniband_verbs | grep ibdev | awk '{print $2}' | sort)
        else
            echo "ibcore module is not loaded"
            exit 2
        fi
fi
echo -e "DEV\tPORT\tINDEX\tGID\t\t\t\t\tIPv4  \t\tVER\tDEV"
echo -e "---\t----\t-----\t---\t\t\t\t\t------------  \t---\t---"
for d in $DEVS ; do
	for p in $(sysctl sys.class.infiniband.$d.ports | awk -F'.' {'print $6'} | uniq | sort) ; do
		for g in $(sysctl -N sys.class.infiniband.$d.ports.$p.gids| awk -F'.' {'print $8'} | sort -g) ; do
                        gid=$(sysctl -n sys.class.infiniband.$d.ports.$p.gids.$g);
                        if [ $gid = 0000:0000:0000:0000:0000:0000:0000:0000 ] ; then
                        	continue
                	fi
                	if [ $gid = fe80:0000:0000:0000:0000:0000:0000:0000 ] ; then
                        	continue
                	fi
			_ndev=$(sysctl -n sys.class.infiniband.$d.ports.$p.gid_attrs.ndevs.$g 2>/dev/null)
			__type=$(sysctl -n sys.class.infiniband.$d.ports.$p.gid_attrs.types.$g 2>/dev/null)
			_type=$(echo $__type| grep -o "[Vv].*")
			if [ $(echo $gid | cut -d ":" -f -1) = "0000" ] ; then
				ipv4=$(printf "%d.%d.%d.%d" 0x${gid:30:2} 0x${gid:32:2} 0x${gid:35:2} 0x${gid:37:2})
	                	echo -e "$d\t$p\t$g\t$gid\t$ipv4  \t$_type\t$_ndev"
			else
				echo -e "$d\t$p\t$g\t$gid\t\t\t$_type\t$_ndev"
			fi
			gid_count=$(expr 1 + $gid_count)
        	done #g (gid)
	done #p (port)
done #d (dev)

echo n_gids_found=$gid_count
