/*-
 * Copyright (c) 2013-2017, Mellanox Technologies, Ltd.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS `AS IS' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD$
 */

#ifndef MLX5_QOS_H
#define MLX5_QOS_H

#include <dev/mlx5/driver.h>

int mlx5_vqos_create_arbiter(struct mlx5_core_dev *mdev, int type,
			     u32 parent_id,
			     u32 bw_share, u32  max_average_bw,
			     u32 *arbiter_id);

void mlx5_vqos_destroy_arbiter(struct mlx5_core_dev *mdev, u32 arbiter_id);

int mlx5_vqos_attach_vport(struct mlx5_core_dev *mdev, int type,
			   u32 attributes, u32 parent_tsar_id,
			   u32 *sched_element_id);
int mlx5_vqos_modify_arbiter(struct mlx5_core_dev *mdev, u32 arbiter_id,
			     u32 bw_share, u32 max_average_bw);
void mlx5_vqos_detach_vport(struct mlx5_core_dev *mdev, u32 sched_element_id);
int mlx5_create_qos_para_vport(struct mlx5_core_dev *mdev, u16 *vport_id);
void mlx5_destroy_qos_para_vport(struct mlx5_core_dev *mdev, u16 vport_id);

#endif /* MLX5_QOS_H */
